report: perf rls notes formatting fixes
[csit.git] / bootstrap-vpp-verify-weekly.sh
1 #!/bin/bash
2 # Copyright (c) 2016 Cisco and/or its affiliates.
3 # Licensed under the Apache License, Version 2.0 (the "License");
4 # you may not use this file except in compliance with the License.
5 # You may obtain a copy of the License at:
6 #
7 #     http://www.apache.org/licenses/LICENSE-2.0
8 #
9 # Unless required by applicable law or agreed to in writing, software
10 # distributed under the License is distributed on an "AS IS" BASIS,
11 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
12 # See the License for the specific language governing permissions and
13 # limitations under the License.
14
15 set -x
16
17 cat /etc/hostname
18 cat /etc/hosts
19
20 VIRL_SERVERS=("10.30.51.28" "10.30.51.29" "10.30.51.30")
21 VIRL_SERVER=""
22
23 VIRL_USERNAME=jenkins-in
24 VIRL_PKEY=priv_key
25 VIRL_SERVER_STATUS_FILE="status"
26 VIRL_SERVER_EXPECTED_STATUS="PRODUCTION"
27 VIRL_SESSION_EXPIRY="620"
28
29 SCRIPT_DIR="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
30
31 # Create tmp dir
32 mkdir ${SCRIPT_DIR}/tmp
33
34 # Use tmp dir to store log files
35 LOG_PATH="${SCRIPT_DIR}/tmp"
36
37 if [ -f "/etc/redhat-release" ]; then
38     DISTRO="CENTOS"
39     sudo yum install -y python-devel python-virtualenv
40     VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_CENTOS)
41     VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_CENTOS)
42 else
43     DISTRO="UBUNTU"
44     export DEBIAN_FRONTEND=noninteractive
45     sudo apt-get -y update
46     sudo apt-get -y install libpython2.7-dev python-virtualenv
47     VIRL_TOPOLOGY=$(cat ${SCRIPT_DIR}/VIRL_TOPOLOGY_UBUNTU)
48     VIRL_RELEASE=$(cat ${SCRIPT_DIR}/VIRL_RELEASE_UBUNTU)
49 fi
50
51 SSH_OPTIONS="-i ${VIRL_PKEY} -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o BatchMode=yes -o LogLevel=error"
52
53 function ssh_do() {
54     echo
55     echo "### "  ssh $@
56     ssh ${SSH_OPTIONS} $@
57 }
58
59 rm -f ${VIRL_PKEY}
60 cat > ${VIRL_PKEY} <<EOF
61 -----BEGIN RSA PRIVATE KEY-----
62 MIIEpQIBAAKCAQEA+IHXq87GcqMR1C47rzx6Cbip5Ghq8pKrbqKrP5Nf41HcYrT6
63 GOXl9nFWKsMOzIlIn+8y7Il27eZh7csQGApbg8QLiHMtcYEmWNzKZpkqg4nuAPxX
64 VXwlKgnKX902SrET9Gp9TDayiHtCRWVfrlPPPSA0UEXW6BjLN/uHJ+W/Xzrrab+9
65 asBVa05vT2W6n0KJ66zfCaeDM912mQ6SttscAwFoWDmdHlegiVqrlIG2ABxOvxxz
66 L3dM3iSmlmQlzv9bThjo+nI4KFYh6m5wrZmAo5r/4q9CIJc21HVnTqkGOWJIZz6J
67 73lePJVSq5gYqaoGw3swFEA/MDkOx7baWKSoLQIDAQABAoIBAQCNBeolNp+JWJ76
68 gQ4fwLsknyXSV6sxYyhkDW4PEwwcTU06uqce0AAzXVffxne0fMe48x47+zqBgPbb
69 4huM+Pu8B9nfojUMr5TaYtl9Zbgpk3F8H7dT7LKOa6XrxvZTZrADSRc30+Z26zPN
70 e9zTaf42Gvt0/l0Zs1BHwbaOXqO+XuwJ3/F9Sf3PQYWXD3EOWjpHDP/X/1vAs6lV
71 SLkm6J/9KKE1m6I6LTYjIXuYt4SXybW6N2TSy54hhQtYcDUnIU2hR/PHVWKrGA0J
72 kELgrtTNTdbML27O5gFWU4PLUEYTZ9fN11D6qUZKxLcPOiPPHXkiILMRCCnG5DYI
73 ksBAU/YlAoGBAPxZO9VO18TYc8THV1nLKcvT2+1oSs1UcA2wNQMU55t910ZYinRa
74 MRwUhMOf8Mv5wOeiZaRICQB1PnVWtDVmGECgPpK6jUxqAwn8rgJcnoafLGL5YKMY
75 RVafTe6N5LXgCaOcJrk21wxs6v7ninEbUxxc575urOvZMBkymDw91dwbAoGBAPwa
76 YRhKhrzFKZzdK0RadVjnxKvolUllpoqqg3XuvmeAJHAOAnaOgVWq68NAcp5FZJv0
77 2D2Up7TX8pjf9MofP1SJbcraKBpK4NzfNkA0dSdEi+FhVofAJ9umB2o5LW1n7sab
78 UIrjsdzSJK/9Zb9yTTHPyibYzNEgaJV1HsbxfEFXAoGAYO2RmvRm0phll18OQVJV
79 IpKk9kLKAKZ/R/K32hAsikBC8SVPQTPniyaifFWx81diblalff2hX4ipTf7Yx24I
80 wMIMZuW7Im/R7QMef4+94G3Bad7p7JuE/qnAEHJ2OBnu+eYfxaK35XDsrq6XMazS
81 NqHE7hOq3giVfgg+C12hCKMCgYEAtu9dbYcG5owbehxzfRI2/OCRsjz/t1bv1seM
82 xVMND4XI6xb/apBWAZgZpIFrqrWoIBM3ptfsKipZe91ngBPUnL9s0Dolx452RVAj
83 yctHB8uRxWYgqDkjsxtzXf1HnZBBkBS8CUzYj+hdfuddoeKLaY3invXLCiV+PpXS
84 U4KAK9kCgYEAtSv0m5+Fg74BbAiFB6kCh11FYkW94YI6B/E2D/uVTD5dJhyEUFgZ
85 cWsudXjMki8734WSpMBqBp/J8wG3C9ZS6IpQD+U7UXA+roB7Qr+j4TqtWfM+87Rh
86 maOpG56uAyR0w5Z9BhwzA3VakibVk9KwDgZ29WtKFzuATLFnOtCS46E=
87 -----END RSA PRIVATE KEY-----
88 EOF
89 chmod 600 ${VIRL_PKEY}
90
91 #
92 # Pick a random host from the array of VIRL servers, and attempt
93 # to reach it and verify it's status.
94 #
95 # The server must be reachable, and have a "status" file with
96 # the content "PRODUCTION", to be selected.
97 #
98 # If the server is not reachable, or does not have the correct
99 # status, remove it from the array and start again.
100 #
101 # Abort if there are no more servers left in the array.
102 #
103 while [[ ! "$VIRL_SERVER" ]]
104 do
105     num_hosts=${#VIRL_SERVERS[@]}
106     if [ $num_hosts == 0 ]
107     then
108         echo "No more VIRL candidate hosts available, failing."
109         exit 127
110     fi
111     element=$[ $RANDOM % $num_hosts ]
112     virl_server_candidate=${VIRL_SERVERS[$element]}
113     virl_server_status=$(ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${virl_server_candidate} cat $VIRL_SERVER_STATUS_FILE 2>&1)
114     echo VIRL HOST $virl_server_candidate status is \"$virl_server_status\"
115     if [ "$virl_server_status" == "$VIRL_SERVER_EXPECTED_STATUS" ]
116     then
117         # Candidate is in good status. Select this server.
118         VIRL_SERVER="$virl_server_candidate"
119     else
120         # Candidate is in bad status. Remove from array.
121         VIRL_SERVERS=("${VIRL_SERVERS[@]:0:$element}" "${VIRL_SERVERS[@]:$[$element+1]}")
122     fi
123 done
124
125 # Temporarily download VPP and DPDK packages from nexus.fd.io
126 case "$DISTRO" in
127         CENTOS )
128             VPP_ARTIFACTS="vpp vpp-selinux-policy vpp-devel vpp-lib vpp-plugins"
129             DPDK_ARTIFACTS=""
130             PACKAGE="rpm"
131             VPP_CLASSIFIER=""
132             DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER).x86_64
133             VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_CENTOS)
134             VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER_CENTOS)
135             ;;
136         UBUNTU )
137             VPP_ARTIFACTS="vpp vpp-dbg vpp-dev vpp-lib vpp-plugins"
138             DPDK_ARTIFACTS="vpp-dpdk-dkms"
139             PACKAGE="deb"
140             VPP_CLASSIFIER="-deb"
141             DPDK_STABLE_VER=$(cat ${SCRIPT_DIR}/DPDK_STABLE_VER)_amd64
142             VPP_REPO_URL=$(cat ${SCRIPT_DIR}/VPP_REPO_URL_UBUNTU)
143             VPP_STABLE_VER=$(cat ${SCRIPT_DIR}/VPP_STABLE_VER_UBUNTU)
144 esac
145
146 if [ "${#}" -ne "0" ]; then
147     arr=(${@})
148     echo ${arr[0]}
149     # Download DPDK parts not included in dpdk plugin of vpp build
150     for ARTIFACT in ${DPDK_ARTIFACTS}; do
151         wget -q "${VPP_REPO_URL}/${ARTIFACT}/${DPDK_STABLE_VER}/${ARTIFACT}-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.${PACKAGE}" || exit
152     done
153 else
154     rm -f *.${PACKAGE}
155     for ARTIFACT in ${DPDK_ARTIFACTS}; do
156         wget -q "${VPP_REPO_URL}/${ARTIFACT}/${DPDK_STABLE_VER}/${ARTIFACT}-${DPDK_STABLE_VER}${VPP_CLASSIFIER}.${PACKAGE}" || exit
157     done
158     for ARTIFACT in ${VPP_ARTIFACTS}; do
159         wget -q "${VPP_REPO_URL}/${ARTIFACT}/${VPP_STABLE_VER}/${ARTIFACT}-${VPP_STABLE_VER}${VPP_CLASSIFIER}.${PACKAGE}" || exit
160     done
161 fi
162
163 VPP_PKGS=(*.$PACKAGE)
164 echo ${VPP_PKGS[@]}
165 VIRL_DIR_LOC="/tmp"
166 VPP_PKGS_FULL=(${VPP_PKGS[@]})
167
168 # Prepend directory location at remote host to deb file list
169 for index in "${!VPP_PKGS_FULL[@]}"; do
170     VPP_PKGS_FULL[${index}]=${VIRL_DIR_LOC}/${VPP_PKGS_FULL[${index}]}
171 done
172
173 echo "Updated file names: " ${VPP_PKGS_FULL[@]}
174
175 # Copy the files to VIRL host
176 scp ${SSH_OPTIONS} *.${PACKAGE} \
177     ${VIRL_USERNAME}@${VIRL_SERVER}:${VIRL_DIR_LOC}/
178
179 result=$?
180 if [ "${result}" -ne "0" ]; then
181     echo "Failed to copy vpp deb files to virl host"
182     echo ${result}
183     exit ${result}
184 fi
185
186 # Start a simulation on VIRL server
187 echo "Starting simulation on VIRL server"
188
189 function stop_virl_simulation {
190     ssh ${SSH_OPTIONS} ${VIRL_USERNAME}@${VIRL_SERVER}\
191         "stop-testcase ${VIRL_SID}"
192 }
193
194 VIRL_SID=$(ssh ${SSH_OPTIONS} \
195     ${VIRL_USERNAME}@${VIRL_SERVER} \
196     "start-testcase -vv --copy ${VIRL_TOPOLOGY} \
197     --expiry ${VIRL_SESSION_EXPIRY} \
198     --release ${VIRL_RELEASE} ${VPP_PKGS_FULL[@]}")
199 retval=$?
200 if [ ${retval} -ne "0" ]; then
201     echo "VIRL simulation start failed"
202     exit ${retval}
203 fi
204
205 if [[ ! "${VIRL_SID}" =~ session-[a-zA-Z0-9_]{6} ]]; then
206     echo "No VIRL session ID reported."
207     exit 127
208 fi
209
210 # Upon script exit, cleanup the simulation execution
211 trap stop_virl_simulation EXIT
212 echo ${VIRL_SID}
213
214 ssh_do ${VIRL_USERNAME}@${VIRL_SERVER} cat /scratch/${VIRL_SID}/topology.yaml
215
216 # Download the topology file from virl session
217 scp ${SSH_OPTIONS} \
218     ${VIRL_USERNAME}@${VIRL_SERVER}:/scratch/${VIRL_SID}/topology.yaml \
219     topologies/enabled/topology.yaml
220
221 retval=$?
222 if [ ${retval} -ne "0" ]; then
223     echo "Failed to copy topology file from VIRL simulation"
224     exit ${retval}
225 fi
226
227
228 virtualenv --system-site-packages env
229 . env/bin/activate
230
231 echo pip install
232 pip install -r ${SCRIPT_DIR}/requirements.txt
233
234 # There are used three iterations of tests there to check
235 # the stability and reliability of the results
236
237 RC=0
238 MORE_FAILS=0
239
240 partial_logs=""
241 for test_set in 1 2 3
242 do
243     echo
244     echo ${test_set}. test loop
245     PYTHONPATH=`pwd` pybot -L TRACE -W 136\
246         -v TOPOLOGY_PATH:${SCRIPT_DIR}/topologies/enabled/topology.yaml \
247         --suite "tests.vpp.func" \
248         --include vm_envAND3_node_single_link_topo \
249         --include vm_envAND3_node_double_link_topo \
250         --exclude PERFTEST \
251         --noncritical EXPECTED_FAILING \
252         --output ${LOG_PATH}/output_test_set${test_set} \
253         tests/
254     PARTIAL_RC=$(echo $?)
255     partial_logs="${partial_logs} ${LOG_PATH}/output_test_set${test_set}.xml"
256     if [ ${PARTIAL_RC} -eq 250 ]; then
257         MORE_FAILS=1
258     fi
259     RC=$((RC+PARTIAL_RC))
260 done
261
262 # Log the final result
263 if [ ${RC} -eq 0 ]; then
264     set +x
265     echo
266     echo "========================================================================================================================================"
267     echo "Final result of all test loops:                                                                                                 | PASS |"
268     echo "All critical tests have passed."
269     echo "========================================================================================================================================"
270     echo
271     set -x
272 elif [ ${MORE_FAILS} -eq 0 ]; then
273     if [ ${RC} -eq 1 ]; then
274         HLP_STR="test has"
275     else
276         HLP_STR="tests have"
277     fi
278     set +x
279     echo
280     echo "========================================================================================================================================"
281     echo "Final result of all test loops:                                                                                                 | FAIL |"
282     echo "${RC} critical ${HLP_STR} failed."
283     echo "========================================================================================================================================"
284     echo
285     set -x
286 else
287     set +x
288     echo
289     echo "========================================================================================================================================"
290     echo "Final result of all test loops:                                                                                                 | FAIL |"
291     echo "More then 250 critical tests have failed in one test loop."
292     echo "========================================================================================================================================"
293     echo
294     set -x
295 fi
296
297 echo Post-processing test data...
298
299 # Rebot output post-processing
300 rebot --noncritical EXPECTED_FAILING \
301       --output output.xml ${partial_logs}
302
303 # Remove unnecessary log files
304 rm -f ${partial_logs}
305
306 echo Post-processing finished.
307
308 if [ ${RC} -eq 0 ]; then
309     RETURN_STATUS=0
310 else
311     RETURN_STATUS=1
312 fi
313
314 exit ${RETURN_STATUS}

©2016 FD.io a Linux Foundation Collaborative Project. All Rights Reserved.
Linux Foundation is a registered trademark of The Linux Foundation. Linux is a registered trademark of Linus Torvalds.
Please see our privacy policy and terms of use.